/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#define MF_SOURCE_NAME  MF_SOURCE_BI_DNS
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

/* This file is part of mailfromd.             -*- c -*-
   Copyright (C) 2006, 2007 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
   MA 02110-1301 USA */

#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>

void
#line 24
bi_primitive_hostname(eval_environ_t env)
#line 24

#line 24 "bi_dns.m4"
{
#line 24
	
#line 24

#line 24

#line 24
char * string = (char *) get_string_arg(env, 0);
#line 24
        
#line 24
        adjust_stack(env, 1);
#line 24

#line 24
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 24
		prog_trace(env, "primitive_hostname %s",string);;
#line 24

{
	char *hbuf;
	mf_status stat;

	stat = resolve_ipstr(string, &hbuf);
		if (!(stat == mf_success))
#line 30
			env_throw_bi(env, stat, "primitive_hostname", _("Cannot resolve IP %s"),string)
#line 33
;
	
	pushs(env, hbuf);
	free(hbuf);
}
}

void
#line 40
bi_primitive_resolve(eval_environ_t env)
#line 40

#line 40 "bi_dns.m4"
{
#line 40
	
#line 40

#line 40
long __bi_argcnt = (long)get_numeric_arg(env, 0);
#line 40
char * string = (char *) get_string_arg(env, 1);
#line 40
        char * domain = (char *) get_string_arg(env, 2);
#line 40
        
#line 40
        adjust_stack(env, __bi_argcnt + 1);
#line 40

#line 40
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 40
		prog_trace(env, "primitive_resolve %s %s",string, ((__bi_argcnt > 1) ? domain : ""));;
#line 40

{
	char *ipstr;
	mf_status stat;
	
	if (((__bi_argcnt > 1) ? domain : "")[0]) {
		stat = resolve_ipstr_domain(string, domain, &ipstr);
			if (!(stat == mf_success))
#line 47
			env_throw_bi(env, stat, "primitive_resolve", _("Cannot resolve %s.%s"),string,domain)
#line 49
;
	} else {
		stat = resolve_hostname(string, &ipstr);
			if (!(stat == mf_success))
#line 52
			env_throw_bi(env, stat, "primitive_resolve", _("Cannot resolve %s"),string)
#line 54
;
	}
	pushs(env, ipstr);
	free(ipstr);
}
}

static int
ipaddr_cmp(const void *a, const void *b)
{
	GACOPYZ_UINT32_T ipa = ntohl(*(GACOPYZ_UINT32_T*)a);
	GACOPYZ_UINT32_T ipb = ntohl(*(GACOPYZ_UINT32_T*)b);
	if (ipa < ipb)
		return -1;
	if (ipa > ipb)
		return 1;
	return 0;
}

void
#line 73
bi_dns_getaddr(eval_environ_t env)
#line 73

#line 73 "bi_dns.m4"
{
#line 73
	
#line 73

#line 73

#line 73
char * string = (char *) get_string_arg(env, 0);
#line 73
        
#line 73
        adjust_stack(env, 1);
#line 73

#line 73
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 73
		prog_trace(env, "dns_getaddr %s",string);;
#line 73

{
	GACOPYZ_UINT32_T ipbuf[64]; /* FIXME: arbitrary limit */
	size_t i, ipcount;
	unsigned long ttl;
	dns_status dnstat;

	dnstat = a_lookup(string, ipbuf, NELEMS(ipbuf), &ipcount,
			  &ttl, NULL, 0);
	switch (dnstat) {
	case dns_success: {
		heap_obstack_begin(env);
		qsort(ipbuf, ipcount, sizeof ipbuf[0], ipaddr_cmp);
		for (i = 0; i < ipcount; i++) {
			struct in_addr addr;
			char *q;
			
			addr.s_addr = ipbuf[i];
			q = inet_ntoa(addr);
			if (i > 0)
				do { int __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
 			
#line 94
do {
#line 94
  char *__s = q;
#line 94
  heap_obstack_grow(env, __s, strlen(__s));
#line 94
} while (0);
		}
		do { int __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);
		
#line 97
do {
#line 97
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 97
  return;
#line 97
} while (0);
	}
	case dns_not_found:
		do {pushs(env, "");
#line 100
return;
#line 100
} while (0);
	default:
			env_throw_bi(env, dns_to_mf_status(dnstat), "dns_getaddr", _("Failed to get A record for %s"),string);
#line 104
	}
}
}

static int
hostname_cmp(const void *a, const void *b)
{
	return strcmp(*(const char**) a, *(const char**) b);
}

void
#line 114
bi_dns_getname(eval_environ_t env)
#line 114

#line 114 "bi_dns.m4"
{
#line 114
	
#line 114

#line 114

#line 114
char * ipstr = (char *) get_string_arg(env, 0);
#line 114
        
#line 114
        adjust_stack(env, 1);
#line 114

#line 114
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 114
		prog_trace(env, "dns_getname %s",ipstr);;
#line 114

{
	dns_status dnstat;
	struct in_addr addr;
	unsigned long ttl;
	char *names[64];

		if (!(inet_aton(ipstr, &addr)))
#line 121
			env_throw_bi(env, mf_invip, "dns_getname", _("Invalid IP: %s"),ipstr)
#line 123
;

	dnstat = ptr_lookup(addr, names, NELEMS(names), &ttl, NULL, 0);
	switch (dnstat) {
	case dns_success: {
		size_t i;
		size_t ncount;

		for (ncount = 0; ncount < NELEMS(names) && names[ncount];
		     ncount++);
		
		qsort(names, ncount, sizeof names[0], hostname_cmp);

		for (i = 0; i < ncount; i++) {
			if (i > 0)
				do { int __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
			
#line 139
do {
#line 139
  char *__s = names[i];
#line 139
  heap_obstack_grow(env, __s, strlen(__s));
#line 139
} while (0);
		}
		do { int __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);

		for (; i < ncount; i++) 
			free(names[i]);

		
#line 146
do {
#line 146
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 146
  return;
#line 146
} while (0);
	}
	case dns_not_found:
		do {pushs(env, "");
#line 149
return;
#line 149
} while (0);
	default:
			env_throw_bi(env, dns_to_mf_status(dnstat), "dns_getname", _("Failed to get PTR record for %s"),ipstr);
#line 153
	}
}
}

void
#line 157
bi_primitive_hasmx(eval_environ_t env)
#line 157

#line 157 "bi_dns.m4"
{
#line 157
	
#line 157

#line 157

#line 157
char * string = (char *) get_string_arg(env, 0);
#line 157
        
#line 157
        adjust_stack(env, 1);
#line 157

#line 157
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 157
		prog_trace(env, "primitive_hasmx %s",string);;
#line 157

{
	mxbuf_t mxbuf;
	mf_status mxstat;

	mxstat = getmx(string, mxbuf);
	
		if (!(mxstat == mf_success || mxstat == mf_not_found))
#line 164
			env_throw_bi(env, mxstat, "primitive_hasmx", _("Cannot get MX records for %s"),string)
#line 167
;

	if (mxstat == mf_success) {
		dns_freemx(mxbuf);
		
#line 171
do {
#line 171
  push(env, (STKVAL) (1));
#line 171
  return;
#line 171
} while (0);
	}
	
#line 173
do {
#line 173
  push(env, (STKVAL) (0));
#line 173
  return;
#line 173
} while (0);
}
}

void
#line 177
bi_getmx(eval_environ_t env)
#line 177

#line 177 "bi_dns.m4"
{
#line 177
	
#line 177

#line 177
long __bi_argcnt = (long)get_numeric_arg(env, 0);
#line 177
char * domain = (char *) get_string_arg(env, 1);
#line 177
        long  resolve = (long ) get_numeric_arg(env, 2);
#line 177
        
#line 177
        adjust_stack(env, __bi_argcnt + 1);
#line 177

#line 177
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 177
		prog_trace(env, "getmx %s %lu",domain, ((__bi_argcnt > 1) ? resolve : 0));;
#line 177

{
	mxbuf_t mxbuf;
	mf_status mxstat;

	if (resolve)
		mxstat = getmxip(domain, mxbuf);
	else
		mxstat = getmx(domain, mxbuf);
		if (!(mxstat == mf_success || mxstat == mf_not_found))
#line 186
			env_throw_bi(env, mxstat, "getmx", _("Cannot get MX records for %s"),domain)
#line 188
;
	if (mxstat == mf_not_found)
		do {pushs(env, "");
#line 190
return;
#line 190
} while (0);
	else {
		int i;
		
		heap_obstack_begin(env);
		for (i = 0; i < MAXMXCOUNT && mxbuf[i]; i++) {
			if (i > 0)
				do { int __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
			
#line 198
do {
#line 198
  char *__s = mxbuf[i];
#line 198
  heap_obstack_grow(env, __s, strlen(__s));
#line 198
} while (0);
		}
		do { int __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);
		dns_freemx(mxbuf);
		
#line 202
do {
#line 202
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 202
  return;
#line 202
} while (0);
	}
}
}

static int
resolve_host(const char *string, unsigned long *ip)
{
	int rc;
	struct in_addr addr;
	char *ipstr;

	if (inet_aton(string, &addr)) {
		*ip = addr.s_addr;
		return 0;
	}
	
	if (resolve_hostname(string, &ipstr) != mf_success)
		return 1;

	rc = inet_aton(ipstr, &addr);
	free(ipstr);
	if (rc == 0) {
		mu_error(_("INTERNAL ERROR at %s:%lu: resolve_hostname returned "
			   "invalid IP address: %s"),
			 __FILE__, __FILE__, ipstr);
		return 1;
	}
	*ip = addr.s_addr;
	return 0;
}

void
#line 234
bi_primitive_ismx(eval_environ_t env)
#line 234

#line 234 "bi_dns.m4"
{
#line 234
	
#line 234

#line 234

#line 234
char * domain = (char *) get_string_arg(env, 0);
#line 234
        char * ipstr = (char *) get_string_arg(env, 1);
#line 234
        
#line 234
        adjust_stack(env, 2);
#line 234

#line 234
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 234
		prog_trace(env, "primitive_ismx %s %s",domain, ipstr);;
#line 234

{
	mxbuf_t mxbuf;
	mf_status mxstat;
	unsigned long ip;
	int rc = 0;
	int i;
	
		if (!(resolve_host(ipstr, &ip) == 0))
#line 242
			env_throw_bi(env, mf_noresolve, "primitive_ismx", _("Cannot resolve host name %s"),ipstr)
;
	
	mxstat = getmx(domain, mxbuf);
	
		if (!(mxstat == mf_success))
#line 247
			env_throw_bi(env, mxstat, "primitive_ismx", _("Cannot get MXs for %s"),domain)
#line 249
;

	for (i = 0; i < MAXMXCOUNT && mxbuf[i]; i++) {
		unsigned long n;
		
		if (!resolve_host(mxbuf[i], &n) && n == ip) {
			rc = 1;
			break;
		}
	}
	dns_freemx(mxbuf);
	
#line 260
do {
#line 260
  push(env, (STKVAL) (rc));
#line 260
  return;
#line 260
} while (0);
}
}

void
#line 264
bi_relayed(eval_environ_t env)
#line 264

#line 264 "bi_dns.m4"
{
#line 264
	
#line 264

#line 264

#line 264
char * s = (char *) get_string_arg(env, 0);
#line 264
        
#line 264
        adjust_stack(env, 1);
#line 264

#line 264
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 264
		prog_trace(env, "relayed %s",s);;
#line 264

{
	
#line 266
do {
#line 266
  push(env, (STKVAL) (relayed_domain_p(s)));
#line 266
  return;
#line 266
} while (0);
}
}

void
#line 270
bi_listens(eval_environ_t env)
#line 270

#line 270 "bi_dns.m4"
{
#line 270
	
#line 270

#line 270
long __bi_argcnt = (long)get_numeric_arg(env, 0);
#line 270
char * s = (char *) get_string_arg(env, 1);
#line 270
        long  port = (long ) get_numeric_arg(env, 2);
#line 270
        
#line 270
        adjust_stack(env, __bi_argcnt + 1);
#line 270

#line 270
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 270
		prog_trace(env, "listens %s %lu",s, ((__bi_argcnt > 1) ? port : 0));;
#line 270

{
	
#line 272
do {
#line 272
  push(env, (STKVAL) (listens_on (s, ((__bi_argcnt > 1) ? port : 25)) == mf_success));
#line 272
  return;
#line 272
} while (0);
}
}

void
#line 276
bi_domainpart(eval_environ_t env)
#line 276

#line 276 "bi_dns.m4"
{
#line 276
	
#line 276

#line 276

#line 276
char * str = (char *) get_string_arg(env, 0);
#line 276
        
#line 276
        adjust_stack(env, 1);
#line 276

#line 276
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 276
		prog_trace(env, "domainpart %s",str);;
#line 276

{
	char *p = strchr(str, '@');
	do {pushs(env, p ? p+1 : str);
#line 279
return;
#line 279
} while (0);
}
}

void
#line 283
bi_localpart(eval_environ_t env)
#line 283

#line 283 "bi_dns.m4"
{
#line 283
	
#line 283

#line 283

#line 283
char * str = (char *) get_string_arg(env, 0);
#line 283
        
#line 283
        adjust_stack(env, 1);
#line 283

#line 283
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 283
		prog_trace(env, "localpart %s",str);;
#line 283

{
	char *p = strchr(str, '@');

	if (p) {
		size_t off;
		size_t size = p - str;
		char *string_space = (char*) env_data_ref(env, (off = heap_reserve(env, size + 1)));
		memcpy(string_space, str, size);
		string_space[size] = 0;
		
#line 293
do {
#line 293
  push(env, (STKVAL) (off));
#line 293
  return;
#line 293
} while (0);
	} else
		do {pushs(env, str);
#line 295
return;
#line 295
} while (0);
}
}


#line 299
void
#line 299
dns_init_builtin()
#line 299
{
#line 299
	#line 24 "bi_dns.m4"
va_builtin_install_ex("primitive_hostname", bi_primitive_hostname, 0, 0, dtype_string, 1, 0, 0, dtype_string);
#line 40 "bi_dns.m4"
va_builtin_install_ex("primitive_resolve", bi_primitive_resolve, 0, 0, dtype_string, 2, 1, 0, dtype_string, dtype_string);
#line 73 "bi_dns.m4"
va_builtin_install_ex("dns_getaddr", bi_dns_getaddr, 0, 0, dtype_string, 1, 0, 0, dtype_string);
#line 114 "bi_dns.m4"
va_builtin_install_ex("dns_getname", bi_dns_getname, 0, 0, dtype_string, 1, 0, 0, dtype_string);
#line 157 "bi_dns.m4"
va_builtin_install_ex("primitive_hasmx", bi_primitive_hasmx, 0, 0, dtype_number, 1, 0, 0, dtype_string);
#line 177 "bi_dns.m4"
va_builtin_install_ex("getmx", bi_getmx, 0, 0, dtype_string, 2, 1, 0, dtype_string, dtype_number);
#line 234 "bi_dns.m4"
va_builtin_install_ex("primitive_ismx", bi_primitive_ismx, 0, 0, dtype_number, 2, 0, 0, dtype_string, dtype_string);
#line 264 "bi_dns.m4"
va_builtin_install_ex("relayed", bi_relayed, 0, 0, dtype_number, 1, 0, 0, dtype_string);
#line 270 "bi_dns.m4"
va_builtin_install_ex("listens", bi_listens, 0, 0, dtype_number, 2, 1, 0, dtype_string, dtype_number);
#line 276 "bi_dns.m4"
va_builtin_install_ex("domainpart", bi_domainpart, 0, 0, dtype_string, 1, 0, 0, dtype_string);
#line 283 "bi_dns.m4"
va_builtin_install_ex("localpart", bi_localpart, 0, 0, dtype_string, 1, 0, 0, dtype_string);

#line 299 "bi_dns.m4"
		
#line 299
}
#line 549 "../src/snarf.m4"

#line 549

